
// Copyright (C) 2008-2009 - INRIA - Michael Baudin
// Copyright (C) 2009 - Digiteo - Michael Baudin
// Copyright (C) 2010 - Digiteo - Michael Baudin
//
// This file must be used under the terms of the GNU Lesser General Public License license
// http://www.gnu.org/copyleft/lesser.html

//
// opustc_gwsupport.hxx
//   Header for the C++ gateway support functions for OPUSTC.
//
#ifndef __SCI_OPUSTC_GWSUPPORT_H__
#define __SCI_OPUSTC_GWSUPPORT_H__

int opustc_AssertNumberOfRows ( char * fname , int ivar , int expected_nrows , int actual_nrows );
int opustc_AssertNumberOfColumns ( char * fname , int ivar , int expected_ncols , int actual_ncols );
int opustc_AssertVariableType ( char * fname , int ivar , int expected_type );
int opustc_GetTokenIndex ( char * fname , int ivar , int * token );
int opustc_GetOneDoubleArgument ( char * fname , int ivar , double * value );
int opustc_GetOneIntegerArgument ( char * fname , int ivar , int * value );
int opustc_GetOneCharArgument ( char * fname , int ivar , char ** value );
int opustc_Double2IntegerArgument ( char * fname , int ivar , double dvalue , int * ivalue );
void opustc_CreateLhsInteger ( int ivar , int value );
void opustc_CreateLhsDouble ( int ivar , double value );

#define opustc_AssertNColumns(fname , ivar , expected_ncols , actual_ncols) \
	if ( opustc_AssertNumberOfColumns(fname , ivar , expected_ncols , actual_ncols) == 0 ) \
{ \
	return 0;\
}

#define opustc_AssertNRows(fname , ivar , expected_nrows , actual_nrows) \
	if ( opustc_AssertNumberOfRows(fname , ivar , expected_nrows , actual_nrows) == 0 ) \
{ \
	return 0;\
}

#define opustc_AssertVarType(fname , ivar , expected_type) \
	if ( opustc_AssertVariableType(fname , ivar , expected_type) == 0 ) \
{ \
	return 0;\
}

#define opustc_gettoken(fname , ivar , token ) \
	if ( opustc_GetTokenIndex(fname , ivar , token ) == 0 ) \
{ \
	return 0;\
}

#define opustc_GetOneDouble(fname,ivar,value) \
	if (opustc_GetOneDoubleArgument(fname,ivar,value)==0) { \
	return 0; \
	}

#define opustc_GetOneInteger(fname,ivar,value) \
	if (opustc_GetOneIntegerArgument(fname,ivar,value)==0) { \
	return 0; \
	}

#define opustc_GetOneChar(fname,ivar,value) \
	if (opustc_GetOneCharArgument(fname,ivar,value)==0) { \
	return 0; \
	}

#define opustc_Double2Integer(fname,ivar,dvalue,ivalue) \
	if (opustc_Double2IntegerArgument(fname,ivar,dvalue,ivalue)==0) { \
	return 0; \
	}

/* ==================================================================== */



#endif /* !__SCI_OPUSTC_GWSUPPORT_H__ */